<template>

    <datepicker v-bind="propsToPass"
                :typeable="true"
                @selected="dateSelected">
    </datepicker>

</template>

<script>

    import Datepicker from 'vuejs-datepicker';

    export default {

        data() {

            return {

                propsToPass: {

                    'input-class': this.styles,

                    format: this.customFormatter
                }
            }
        },

        components: { Datepicker },

        props: {

            value: { type: String },

            styles: { type: Object, default: () => { return { 'form-control m-input': true }}}
        },

        methods: {

            /**
             * Set default value of date picker if exists.
             */
            setDefaultValue(value) {

                let date = moment(value).toDate();

                if (! isNaN(date.getTime())) {

                    this.$set(this.propsToPass, 'value', moment(value).toDate());
                }
            },


            /**
             * Convert date to given format.
             *
             * @param date
             */
            customFormatter(date) {

                return moment(date).format('YYYY-MM-DD');
            },


            /**
             * Convert selected date to specific format.
             *
             * @param date
             */
            dateSelected(date) {

                this.$emit('input', date == null ? null : this.customFormatter(date));
            }
        },

        watch: {

            /**
             * If default value with v-model, convert to date object.
             *
             * @param newValue
             */
            value(newValue) {

                newValue !== '' &&
                newValue !== null &&
                newValue !== '0000-00-00' ?
                    this.setDefaultValue(newValue) :
                    null;
            },


            /**
             * Reactive input classes.
             */
            styles: {

                handler(newInputClass) {

                    this.propsToPass['input-class'] = newInputClass
                },

                deep: true
            }
        }
    }

</script>